//+------------------------------------------------------------------+
//|                                               euroform V 3.0.mq4 |
//|                Copyright  2006, Nick Bilak, beluck[AT]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nick Bilak"
#property link      "http://www.mql4.info/"
#include <stdlib.mqh>


extern int  MagicNumber=197893;
extern string EAName="euroform V 3.0";

extern double ProfitExit = 25; //% profit exit per position
extern double EquityGainPercent = 50; //Global percentage of equity exit
extern double Open_Loss_To_CloseTrades=-1000;
extern string PARAMETERS_FILTER = "PARAMETERS FILTER";
extern bool UseHourTrade = false;
extern int FromHourTrade = 8;
extern int ToHourTrade = 18;
extern int TakeProfit1=60; // 1st pip Exit
extern int BreakEven=200; // Breakeven
extern int StopLoss=500;  // Initial Stop
extern int        EMATimeFrame    =  0;
extern int        Price           =  0;
extern int        EMAPeriod       = 60;
extern int        EMAShift        =  2;    
extern int        InitialStop     =  0; 
extern int  OrderPipsDiff=5;
extern string i0="_indicators params_";
extern string i1="__volatility__";
extern int rtP=7;
extern int Voltrp=9;
extern int Voltype=1;
extern double  VolatilityHL=50;
extern string i2="__rsi2ma__";
extern int MA1pr=2;
extern int MA1type=14;
/*
MODE_SMA       0     Simple moving average, 
MODE_EMA       1     Exponential moving average, 
MODE_SMMA      2     Smoothed moving average, 
MODE_LWMA      3     Linear weighted moving average.
MODE_DEMA      4     Double Exponential Moving Average. 
MODE_TEMA      5     Triple Exponential Moving Average.
MODE_T3MA      6     T3 Moving Average. 
MODE_JMA       7     Jurik Moving Average. 
MODE_HMA       8     Hull Moving Average. 
MODE_DECEMA    9     DECEMA Moving Average. 
MODE_SALT      10    Slow Adaptive Trend Line
MODE_TMA       11    Triangular moving average
MODE_FATL      12    Fast Adaptive Trend Line. 
MODE_RSTL      13    Referance Slow Trend Line 
MODE_SDL       14    Slope Directional Line
MODE_Kaufman2  15    Kama / Kaufman2 Indicator
MODE_NonLagMA  16    NonLagMA 
*/
extern int MA2pr=3;
extern int MA2type=1;
extern int RSItpr=3;

extern double  MAofRSIUpHL=75;
extern double  MAofRSIDwnHL=25;

extern string  DS ="Slope Direction Line";
extern int       period=40;
extern int       method=2;
extern int       price=0;

extern int MOMPeriod = 50;

extern double TM_Period = 7;
extern double TM_Shift = 2;

extern string i3="__deltastop__";
extern int     Mode=1; //0 - auto, 1 - manual
extern double  DeltaPrice=0.005;
extern int     ATRperiod=14;
extern double  ATRratio=3.824;

extern int    ConsecutiveTrades=3;
extern int CancelOrderBars=4;

extern double Lots = 0.01;  
extern double MaximumRisk = 2;
extern int    LotDigits = 1;  
extern bool   FixedLot = false;

extern int    slippage=2;   	//slippage for market order processing
extern int    shift=1;			//shift to current bar for entry 
extern int    OrderTriesNumber=10;

bool buysig,sellsig,closebuy,closesell,cancel,addbuy,addsell,exit,remorder,TrStop; 
int ord,tries,last,buys,sells,SL, BreakEvenStop,co,mkt,lastsig,TrailStop;
bool Long1,Long2,Long3,Long4,Long5,Short1,Short2,Short3,Short4,Short5;
double atrstop,atrentry,_1stentry,entryprice,_1stlots,avgpositionprofit,hbuy,lsell,curprof,tickvalue;
double nextTP;
bool sl,Trail_Stop;
int range = 5;
int multiplier;
int Slippage=5;



int init()
{
   sl=0;
  
   Trail_Stop=0;
     //----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
	//----------------------- SOURCE : PENGIE
   MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   
	//----
   return(0);
}


//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {

   if (UseHourTrade){
   if((Hour()>=FromHourTrade)&&(Hour()<=ToHourTrade))
      Comment("Trading Hours");
   else
     {
      Comment("Non-trading Hours");
      return(0);
     }
   }
 
	
   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
	
   co=CalculateCurrentOrders(Symbol());
	
   CheckForSignals();
   if (co>0) CheckForClose();
   CheckForOpen();
   
   co=CalculateCurrentOrders(Symbol());
	
   if (mkt>0) {
      BreakEvenStop(BreakEven,0);
      
   getSpread();
   getOpenOrders();
   TrailStop();
   ScanTrades();
   
   if (ScanTrades()<1) return(0);
   else
   if (EMAPeriod >0) TrailStop(); 
   
 return(0);

      
      
		{
			double pcnt =( (AccountEquity()-AccountBalance()) / AccountBalance())*100;
			Print("Account equity = ",AccountEquity());
			Print("Account balance = ",AccountBalance());
			
			if(pcnt>EquityGainPercent)
			{ 
				int total = OrdersTotal();
				for(int i=total-1;i>=0;i--)
				{
					OrderSelect(i, SELECT_BY_POS);
					int type   = OrderType();
					
					bool result = false;
					
					switch(type)
					{
						//Close opened long positions
					case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
						break;
						
						//Close opened short positions
					case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
						break;
						
						//Close pending orders
					case OP_BUYLIMIT  :
					case OP_BUYSTOP   :
					case OP_SELLLIMIT :
					case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
					}
					
					if(result == false)
					{
						Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
						Sleep(3000);
					}  
				}
				
				
				Print("ALL ORDERS CLOSE-->Locked in on Profits");
			}
		
	
		 if (AccountProfit()<= Open_Loss_To_CloseTrades)
   {
    for(i=OrdersTotal()-1;i>=0;i--)
       {
              
       switch(type)
          {
          //Close opened long positions
          case OP_BUY  : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Pink);
                         break;
               
          //Close opened short positions
          case OP_SELL : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,Pink);
                          
          }
          
       if(result == false)
          {
            Sleep(3000);
          }  
       }
      Print ("Account Cutoff Limit Reached. All Open Trades Have Been Closed");
      return(0);
   }  
   
   Comment("Balance: ",AccountBalance(),", Account Equity: ",AccountEquity(),", Account Profit: ",AccountProfit(),
           "\nMy Account Cutoff Limit: ",Open_Loss_To_CloseTrades);
   
  return(0);
}

  }
}
			
		
		//+------------------------------------------------------------------+
   
	


//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
{
   int ord; mkt=0;
	//----
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==symbol && OrderMagicNumber()== MagicNumber) {
         ord++;
         if (OrderType()==OP_BUY || OrderType()==OP_SELL) mkt++;
      }
   }
	//---- return orders volume
   return(ord);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {
	
	addsell=false;
	addbuy=false;
	buysig=false;
	sellsig=false;
	closebuy=false;
	closesell=false;
	exit=false;
	remorder=false;
	TrailStop=false;
	
   	double VolCH=iCustom(NULL,0,"volatility",rtP,Voltrp,Voltype,0,shift);
   	double RSIndex1=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift);
   	double MAofRSI11=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift);
   	double MAofRSI21=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift);
   	double RSIndex2=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift+1);
   	double MAofRSI12=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift+1);
   	double MAofRSI22=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift+1);
   	double TrailStop=iCustom(NULL,0,"delta-stop",Mode,DeltaPrice,ATRperiod,ATRratio,0,shift);
   	double TML=iCustom(NULL,0,"TrendManager",TM_Period,TM_Shift,1,shift);
   	double TMS=iCustom(NULL,0,"TrendManager",TM_Period,TM_Shift,0,shift);
   	double MOM = iCustom (NULL,0,"Momentum-ZL",MOMPeriod,0,shift);
   	double SDLL = iCustom(NULL,0,"Slope Direction Line",period,method,price,1) ;
      double SDLS = iCustom(NULL,0,"Slope Direction Line",period,method,price,0) ;

	

	
      double VolHL=VolatilityHL;
      double HL1=MAofRSIUpHL;
      double HL2=MAofRSIDwnHL;
      double HLM=50;

      bool Long1 = MAofRSI11>MAofRSI21 && MAofRSI12<=MAofRSI22 && VolCH>VolHL && RSIndex1<HLM && RSIndex1>HL2 && TrailStop<Close[shift] && SDLL;
      
      bool Short1 = MAofRSI11<MAofRSI21 && MAofRSI12>=MAofRSI22 && VolCH>VolHL && RSIndex1<HL1 && RSIndex1>HLM && TrailStop>Close[shift] && SDLS;
      
      bool Long2 = MAofRSI11>HLM && MAofRSI12<=HLM && MAofRSI21>HLM && MAofRSI22<=HLM && VolCH>VolHL && TrailStop<Close[shift] && SDLL;
      
      bool Short2 = MAofRSI11<HLM && MAofRSI12>=HLM && MAofRSI21<HLM && MAofRSI22>=HLM && VolCH>VolHL && TrailStop>Close[shift] && SDLS;
      
      bool Long3 = RSIndex1-RSIndex2>=60 && TrailStop<Close[shift] && SDLL;
      
      bool Short3 = RSIndex2-RSIndex1>=60 && TrailStop>Close[shift] && SDLS;

      bool Long4 = TML && MOM>0.0 && TrailStop<Close[shift] && SDLL;
	
	   bool Short4 = TMS && MOM<0.0 && TrailStop>Close[shift] && SDLS;

      buysig = Long1 || Long2 || Long3 || Long4;
      sellsig = Short1 || Short2 || Short3 || Short4;
	
	closebuy=sellsig;
	closesell=buysig;
	
	if (curprof>=AccountEquity()*ProfitExit/100.0) {
		exit=true;
	}
	if (last>0 && (Time[0]-last)/(Period()*60)>=CancelOrderBars) {
		remorder=true;
		
	}
}

void CheckForOpen() {
   int    res,tr;
	
	//---- sell conditions
   co=CalculateCurrentOrders(Symbol());
   if(sellsig && lastsig!=-1)  {
      co=CalculateCurrentOrders(Symbol());
	   if (co==0) {
			if ( Short1 == true)Print(" Short1 signal taken ");
			if ( Short2 == true)Print(" Short2 signal taken ");
			if ( Short3 == true)Print(" Short3 signal taken ");
			if ( Short4 == true)Print(" Short4 signal taken ");
			res = OpenStop(OP_SELLSTOP,LotsRisk(StopLoss), Low[shift]-OrderPipsDiff*Point, StopLoss, TakeProfit1);
	   }
	   lastsig=-1;
	   last=Time[0];
      return;
   }
	//---- buy conditions
   co=CalculateCurrentOrders(Symbol());
   if(buysig && lastsig!=1)  {
      co=CalculateCurrentOrders(Symbol());
	   if (co==0) {
			if ( Long1 == true) Print(" Long1 signal taken ");
			if ( Long2 == true)Print(" Long2 signal taken ");
			if ( Long3 == true) Print(" Long3 signal taken ");
			if ( Long4 == true)Print(" Long4 signal taken ");
			res = OpenStop(OP_BUYSTOP,LotsRisk(StopLoss), High[shift]+OrderPipsDiff*Point, StopLoss, TakeProfit1);
	   }
	   last=Time[0];
	   lastsig=1;
      return;
   }
}
bool CloseAtMarket(int ticket,double lot) {
   //fault tolerant market order closing
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      tries++;
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
   }
   if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
}

int OpenStop(int mode,double lot, double prc, int SL, int TP) {
   int    res,tr,col;
   string mail;
   double openprice,sl,tp,stlev;
   tries=0;
   stlev=(1+MarketInfo(Symbol(),MODE_STOPLEVEL))*Point;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELLSTOP) {
         if (prc<=Bid-stlev) openprice=prc; 
         else openprice=Bid-stlev; 
         if (SL>0) sl=openprice+SL*Point;
         if (TP>0) tp=openprice-TP*Point;
			
         col=Red;
      } else
      if (mode==OP_BUYSTOP) {
         if (prc>=Ask+stlev) openprice=prc; 
         else openprice=Ask+stlev; 
         if (SL>0) sl=openprice-SL*Point;
         if (TP>0) tp=openprice+TP*Point;
			
         col=Blue;
      } else return;
      Print(Ask," ",Bid," ",Symbol(),"  ",mode,"  ",lot,"  ",openprice,"  ",sl,"  ",tp,"  ");
      res=OrderSend(Symbol(),mode,lot,openprice,slippage,sl,tp,EAName+"_"+ MagicNumber, MagicNumber,0,col);
      tries++;
   }
   if (res<=0) Print("Error opening pending order : ",ErrorDescription(GetLastError()));
   return(res);
} 
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
   bool bres; int tr;
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  continue;
      if(OrderMagicNumber()!= MagicNumber || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY && exit) {
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if(OrderType()==OP_SELL && exit) {
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if(OrderType()==OP_BUYSTOP && (closebuy || remorder)) {
         bres=DeletePending(OrderTicket());
         continue;
      }
      if(OrderType()==OP_SELLSTOP && (closesell || remorder)) {
         bres=DeletePending(OrderTicket());
         continue;
      }
   }
}

bool DeletePending(int ticket) {
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      bres=OrderDelete(ticket);
      tries++;
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
   }
   if (!bres) Print("Error deleting order : ",ErrorDescription(GetLastError()));
   return (bres);
}

double LotsRisk(int StopLoss)  { 
   double lot=Lots;
   int SL=StopLoss;
   if (SL==0) SL=100;
	//---- select lot size
   if (!FixedLot)
      lot=AccountFreeMargin()*MaximumRisk*0.001/SL;
   lot=NormalizeDouble(lot,LotDigits);
	//---- return lot size
   if(lot<MarketInfo(Symbol(),MODE_MINLOT)) lot=MarketInfo(Symbol(),MODE_MINLOT);
   return(lot);
}

void BreakEvenStop(int BES, int BELP) {
   //move stoploss to lock some profit
   bool bres;
   double StopLoss;
   if ( BES > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() !=  MagicNumber )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+BES*Point )  continue;
            StopLoss = OrderOpenPrice()+BELP*Point;
            if ( StopLoss > OrderStopLoss() ) {
					bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
					if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
			
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-BES*Point )  continue;
            StopLoss = OrderOpenPrice()-BELP*Point;
            if ( StopLoss < OrderStopLoss() ) {
					bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
					if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}
//========== FUNCTION getPipValue
double getPipValue(double ord,int dir)
{
   double val;
   RefreshRates();
   if(dir == 1) val=(NormalizeDouble(ord,Digits) - 
NormalizeDouble(Ask,Digits));
   else val=(NormalizeDouble(Bid,Digits) - NormalizeDouble(ord,Digits));
   val = val/Point*co;
   return(val);
}
//== end function

int getSpread()
{
   int spread=MarketInfo(Symbol(),MODE_SPREAD);
   return(spread);
}



//========== FUNCTION getOpenOrders
void getOpenOrders()
{
   int nsl, nsd;
   string mngMagic, trailon;
   int totalorders = OrdersTotal();
   for(int j=0; j<totalorders;j++)
     {
         OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
         if((OrderType() == OP_BUY || OrderType() == OP_SELL) && 
OrderSymbol() == Symbol()&&(MagicNumber==0 || MagicNumber == 
OrderMagicNumber()))
         {

            double val=getPipValue(OrderOpenPrice(),OrderType());
            //int val = OrderProfit()/(OrderLots()*10);
            
           

         }

         if(MagicNumber == 0)
         mngMagic = "All "+Symbol()+" trades.";
         else
         mngMagic = "Trades with magic number = "+MagicNumber;




         //RefreshRates();
         Comment("Balance: ",AccountBalance(),", Account Equity: ",AccountEquity(),", Account Profit: ",AccountProfit(),"Order Open: ",OrderOpenPrice(),
         "\nPip Count: ", val,
         "\nMy Account Cutoff Limit: ",Open_Loss_To_CloseTrades,
         "\nManaging: ", mngMagic);



     }
}


void TrailStop()
{
   double minstop = MarketInfo(Symbol(),MODE_STOPLEVEL);
   double ask = MarketInfo(Symbol(),MODE_ASK);
   double bid = MarketInfo(Symbol(),MODE_BID);
   double ema = iMA(Symbol(),EMATimeFrame,EMAPeriod,0,MODE_EMA,Price,EMAShift);
   
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol()) 
      {
         if (mode==OP_BUY) 
         {
			double BuyStop = ema;
			if(OrderStopLoss() == 0 && InitialStop>0 ) BuyStop = Bid-InitialStop*Point;  
			if((bid - BuyStop) < minstop*Point) BuyStop = bid - minstop*Point;   
			Print("MA=",ema," BuyStop=",BuyStop);
			   if ((OrderOpenPrice() <= BuyStop && BuyStop > OrderStopLoss()) || OrderStopLoss()==0) 
			   {
			   bool result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                             NormalizeDouble(BuyStop, Digits),
			                             OrderTakeProfit(),0,LightGreen);
			      if( !result )
               {
               Print("BUY: OrderModify failed with error #",GetLastError());
               }
			      return(0);
                          
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
         double SellStop = ema;   
         if (OrderStopLoss()==0 && InitialStop > 0) SellStop = ask+InitialStop*Point;
         if((SellStop-ask) < minstop*Point)  SellStop = ask + minstop*Point;  
         Print("MA=",ema," SellStop=",SellStop);   
            if( (OrderOpenPrice() >= SellStop && OrderStopLoss() > SellStop) || OrderStopLoss()==0) 
            {
            OrderModify(OrderTicket(), OrderOpenPrice(),
                        NormalizeDouble(SellStop, Digits),
			               OrderTakeProfit(),0,DarkOrange);
               if( !result )
               {
               Print("SELL: OrderModify failed with error #",GetLastError());
               }
               return(0);
               
   			}	    
         }
      }
   }     
}


// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELL) 
   numords++;
   }
   return(numords);
}









//+------------------------------------------------------------------+
//+--------------------------END OF PROGRAM--------------------------+


//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE

int subGenerateMagicNumber(int MagicNumber, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSD")       isymbol = 1;
   else if (symbol == "GBPUSD")  isymbol = 2;
   else if (symbol == "USDJPY")  isymbol = 3;
   else if (symbol == "USDCHF")  isymbol = 4;
   else if (symbol == "AUDUSD")  isymbol = 5;
   else if (symbol == "USDCAD")  isymbol = 6;
   else if (symbol == "EURGBP")  isymbol = 7;
   else if (symbol == "EURJPY")  isymbol = 8;
   else if (symbol == "EURCHF")  isymbol = 9;
   else if (symbol == "EURAUD")  isymbol = 10;
   else if (symbol == "EURCAD")  isymbol = 11;
   else if (symbol == "GBPUSD")  isymbol = 12;
   else if (symbol == "GBPJPY")  isymbol = 13;
   else if (symbol == "GBPCHF")  isymbol = 14;
   else if (symbol == "GBPAUD")  isymbol = 15;
   else if (symbol == "GBPCAD")  isymbol = 16;
   else                          isymbol = 17;
   if(isymbol<10) MagicNumber = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
   
}


